#include <libac.h>

static uint8_t  _led_opt;
static uint16_t _led_qnt;

static void _led_quant(int16_t led_maxlevel)
{
  if (led_maxlevel > 8)
  {
    _led_qnt = led_maxlevel / 8;
    _led_opt = LED_FILL | LED_MARGIN(/* Bit */ 0 /* is margin */);
  }
  else if (led_maxlevel < -8)
  {
    _led_qnt = led_maxlevel / -8;
    _led_opt = LED_FILL | LED_MARGIN(/* Bit */ 7 /* is margin */);
  }
  else
  {
    _led_qnt = 0;
    /* margin or other led_options are unused - raw i/f */
  }
}

static void _led_graph(int8_t bit)
{
  int8_t absbit = bit + ((_led_opt >> 1) & 0x7);

  if (_led_opt & LED_FILL)
  {
    if (absbit > (absbit - bit))	/* bar from bottom to top */
    {
      outp( (   ((1 << absbit) + ((1 << absbit) - 1))
             & ~((1 << (absbit - bit)) - 1)                           ),
                (LED_PORT)                                            );
      return;
    }
    else if (absbit < (absbit - bit))	/* bar from top to bottom */
    {
      outp( (   ((1 << (absbit - bit)) - 1) & ~((1 << absbit) - 1)    ),
                (LED_PORT)                                            );
      return;
    }
  }

  if (absbit < 0)
  {
    led_cls();
    return;
  }

  outp((1 << absbit), (LED_PORT));
}

void led_graph_init(int16_t led_maxlevel)
{
  _led_quant(led_maxlevel);
  outp(0xff, (LED_PORT) - 1);    // output port (default mode)
  led_cls();
}

void led_graph_put(int16_t bitset_level)
{
  if (_led_qnt)
    /* use led_options for output */
    _led_graph((int8_t)(bitset_level / _led_qnt));
  else
    /* raw i/f */
    outp((uint8_t)bitset_level, (LED_PORT));
}

void led_graph_control(int16_t led_maxlevel, int8_t led_options)
{
  _led_quant(led_maxlevel);
  _led_opt = led_options;
}
